<template>
  <div>
    <div>
      <div v-if="!tariffError">
        <template v-if="tariffEmpty">
          <div
            v-if="!isOnlyManualTariff"
            class="tariff-empty ob-order-info-status__tariff-header"
          >
            <i class="icon info"></i>
            Для вашего маршрута доступны онлайн-цена и свой тариф
          </div>
          <div v-else class="tariff-empty ob-order-info-status__tariff-header">
            <i class="icon info"></i>
            Для вашего маршрута доступен свой тариф
          </div>
        </template>
        <template v-if="!tariffEmpty">
          <div
            class="ob-order-info-status__tariff-header ob-order-info-status__tariff-header--exist"
          >
            <i class="icon checked"></i>
            Для вашего маршрута найдены тарифы<br />из договора
          </div>
          <div
            :class="{ 'tariff-items--only': tariffs.length === 1 }"
            class="tariff-items"
            v-if="!tariffError && !tariffEmpty"
          >
            <tariff
              v-for="(item, index) in openedTariffs"
              :key="item.tariffUuid"
              :tariff="item"
              :shouldBeChecked="tariff === item.tariffUuid"
              :index="index"
              @tariffChanged="onTariffChanged"
            />
            <span
              class="expand-tariff"
              v-if="hiddenTariffs.length && !tariffsExpanded"
              @click="tariffsExpanded = true"
            >
              Показать ещё {{ this.hiddenTariffs.length }}
              <i class="icon chevron-down"></i>
            </span>
            <expand-transition>
              <div v-if="tariffsExpanded">
                <tariff
                  v-for="(item, index) in hiddenTariffs"
                  :key="item.tariffUuid"
                  :tariff="item"
                  :shouldBeChecked="tariff === item.tariffUuid"
                  :index="index"
                  @tariffChanged="onTariffChanged"
                />
                <span
                  class="expand-tariff"
                  v-if="tariffsExpanded"
                  @click="tariffsExpanded = false"
                >
                  Свернуть
                  <i class="icon chevron-up"></i>
                </span>
              </div>
            </expand-transition>
          </div>
        </template>
        <div class="online-price" v-if="!tariffError && !isOnlyManualTariff">
          <ob-radio
            label="Онлайн-цена"
            valueInput="onlinePrice"
            v-model="tariff"
            name="tariff"
            data-qa="price_online"
            @change="$emit('tariffChanged', tariff)"
          />
          <div class="fetched-contracts" v-if="fetchedContracts.length">
            <contracts ref="onlinePriceContracts" v-if="tariff === 'onlinePrice'" :fetchedContracts="fetchedContracts" @contractChanged="$emit('contractChanged', $event)" />
          </div>
        </div>
        <template v-if="!tariffError">
          <div class="tariff-items tariff-items--hand">
            <ob-radio
              label="Назначить тариф"
              v-model="tariff"
              valueInput="tariffByHand"
              name="tariff"
              data-qa="setTariffByHand"
              @change="$emit('tariffChanged', tariff)"
            />
            <div class="fetched-contracts" v-if="fetchedContracts.length">
              <contracts v-if="tariff === 'tariffByHand'" :fetchedContracts="fetchedContracts" @contractChanged="$emit('contractChanged', $event)" />
            </div>
            <div class="ob-order-info-status__manual-tariff" v-if="tariff === 'tariffByHand'">
              <ob-checkbox
                v-if="manualTariffVat > 0"
                label="С учётом НДС"
                v-model="includeVat"
                @change="$emit('updateTariffByHand', finalTariffByHand)"
              />
              <ob-input
                ref="tariffByHandInput"
                v-model="tariffByHandValue"
                :label="tariffByHandLabel"
                subTitle="руб"
                type="money:2"
                data-qa="tariffByHandValue"
                @focus="onHandTariffFocus"
                @input="$emit('updateTariffByHand', finalTariffByHand)"
              />
              <p
                v-if="
                  tariff === 'tariffByHand' &&
                    manualTariffVat && manualTariffVat !== 0
                "
                class="tariff-items--tax"
              >
                НДС:
                {{ manualTariffTax | currency({ dot: 2 }) }} ₽
              </p>
              <p
                v-if="
                  tariff === 'tariffByHand' &&
                    (!manualTariffVat || manualTariffVat === 0)
                "
                class="tariff-items--tax"
              >
                НДС не облагается
              </p>
            </div>
          </div>
        </template>
      </div>
      <div v-if="tariffError" class="ob-order__status tariff-error">
        <div class="ob-order-info-status__tariff-header">
          <i class="icon info"></i>
          Ошибка при поиске тарифа
        </div>
        <div class="ob-order-info-status__tariff-text">
          <p>
            Что-то пошло не так. Попробуйте ещё раз.
          </p>
          <p>
            Если ошибка будет повторяться, свяжитесь со службой поддержки платформы {{ $options.contacts[platform].title }} по телефону <a :href="`tel:${$options.contacts[platform].linkphone}`">{{ $options.contacts[platform].phone }}</a> или почте <a :href="`mailto:${$options.contacts[platform].email}`">{{ $options.contacts[platform].email }}</a>
          </p>
        </div>
        <div class="ob-order__action">
          <ob-button
            label="Попробовать ещё раз"
            :isFullWidth="true"
            data-qa="btnTryAgain"
            @click="$emit('retakeTariff')"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { formatNumber } from "common-components/src/helpers/common";
import obRadio from "common-components/src/obComponents/obRadio";
import obButton from "common-components/src/obComponents/obButton";
import obInput from "common-components/src/obComponents/obInput";
import expandTransition from "common-components/src/obComponents/obExpandTransition";
import { contacts } from "@/resources/contacts";
import tariff from "./draftTariff";
import contracts from "./fetchedContracts";
import obCheckbox from 'common-components/src/obComponents/obCheckbox';
export default {
  name: "clicar-sidebar",

  components: {
    obRadio,
    obButton,
    obInput,
    expandTransition,
    tariff,
    contracts,
    obCheckbox
  },

  props: {
    tariffs: {
      type: Array,
      default: () => [],
    },

    tariffError: {
      type: Boolean,
      default: false,
    },

    tariffEmpty: {
      type: Boolean,
      default: false,
    },

    isOnlyManualTariff: {
      type: Boolean,
      default: false,
    },

    manualTariffVat: {
      type: [String, Number],
      default: 0,
    },

    fetchedContracts: {
      type: Array,
      default: () => []
    }
  },

  contacts,

  data() {
    return {
      tariff: this.isOnlyManualTariff ? "tariffByHand" : null,
      tariffByHandValue: "",
      tariffsExpanded: false,
      includeVat: false
    };
  },

  watch: {
    tariff(newVal) {
      if (newVal) {
        this.tariffByHandValue = "";
      }
    },
  },

  computed: {
    tariffByHandLabel() {
      return `Тариф ${this.includeVat ? 'с' : 'без'} НДС`;
    },
    manualTariffTax() {
      return this.includeVat ? this.tariffByHandValue / 100 - (this.tariffByHandValue / 100) * (100 / (100 + this. manualTariffVat)) : ((this.tariffByHandValue / 100) * this.manualTariffVat) / 100;
    },

    finalTariffByHand() {
      if (this.tariffByHandValue.length) {
        const vat = this.includeVat ? this.tariffByHandValue / 100 - (this.tariffByHandValue / 100) * (100 / (100 + this. manualTariffVat)) + '' : 0
        return this.tariffByHandValue - (vat * 100).toFixed() + '';
      }
      return '';
    },

    openedTariffs() {
      if (this.tariffs.length > 3) {
        const res = [...this.tariffs];
        return res.splice(0, 3);
      }
      return this.tariffs;
    },

    hiddenTariffs() {
      if (this.tariffs.length <= 3) {
        return [];
      }

      const res = [...this.tariffs];
      return res.splice(3);
    },

    platform() {
      return window.OBOZ_CONFIG.OBOZ_API_HOST.includes("oboz")
        ? 'oboz' : "gruzi";
    }
  },

  methods: {
    formatNumber,

    onHandTariffFocus() {
      this.tariff = "tariffByHand";
      // this.$emit("tariffChanged", "tariffByHand");
    },

    onTariffChanged($event) {
      this.tariff = $event;
      if (this.$refs.onlinePriceContracts) {
        this.$refs.onlinePriceContracts.reset();
      }
      this.$emit("tariffChanged", $event);
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
@import "~common-components/src/static/css/variables";

.ob-order-info-status__tariff-header {
  margin-top: 5px;
  margin-bottom: 15px;
  display: flex;
  align-items: center;
  font-size: 16px;
  line-height: 1.2;
  letter-spacing: 0.4px;
  font-weight: 700;

  .icon {
    margin-right: 16px;
    font-size: 24px;
  }

  .info {
    color: $color-error;
  }

  &--exist {
    color: $color-green-light;
    align-items: flex-start;
  }
}

.ob-order-info-status__tariff-text {
  margin-top: 18px;
  font-size: 14px;
  letter-spacing: 0.4px;
  color: $gray-slate;
}

.ob-order-info-status__tariff-info {
  margin-top: 36px;
}

.ob-order-info-status__tariff-item {
  b {
    font-size: 20px;
  }

  p {
    margin-top: 7px;
    font-size: 14px;
    line-height: 16px;
    letter-spacing: 0.4px;
    color: #191e32;

    .icon {
      position: relative;
      top: 2px;
      right: -1px;
      margin-right: 3px;
      color: #004bc8;
      font-weight: bold;
    }
  }
}

.tariff-items {
  margin-bottom: 30px;

  &--hand {
    margin-top: 30px;
  }

  span {
    display: flex;
    align-items: center;
    margin-left: 25px;
    margin-top: 6px;
    font-weight: normal;
    font-size: 14px;
    line-height: 16px;
    letter-spacing: 0.4px;
    color: $gray-slate;

    .icon {
      margin-right: 5px;
      color: #004bc8;
    }
  }

  &--only {
    span {
      margin-left: 0;
    }
  }

  .ob-input-container {
    margin-top: 14px;
  }
}

.tariff-items--tax {
  margin-top: 10px;
  font-size: 12px;
  line-height: 12px;
  letter-spacing: 0.4px;
  color: $gray-slate;
}

.tariff-item {
  &:not(:last-child) {
    margin-bottom: 25px;
  }
  ::v-deep {
    .ob-radio-container label {
      font-weight: bold;
      font-size: 20px;
      line-height: 24px;
      color: $gray-slate;
    }
  }
}

.online-price {
  margin-top: 30px;
}

.ob-order-info-status__tariff-text {
  margin-bottom: 30px;
}

span.expand-tariff {
  margin-left: 0;
  @include font-mixin(12px, 14px, 400, $color-blue-navy-blue);
}

.tariff-empty.ob-order-info-status__tariff-header,
.tariff-empty.ob-order-info-status__tariff-header .info {
  color: $color-blue-navy-blue;
}

.tariff-item-price {
  display: flex;
  justify-content: space-between;
  align-items: center;
  font-size: 15px;

  &::v-deep {
    .icon {
      color: #0070a6;
      cursor: pointer;
    }
  }
}

.tariff-item-total {
  display: flex;
  align-items: flex-end;

  span {
    margin-top: 0;
    margin-bottom: 3px;
    margin-left: 0.5em;
  }
}

.tariff-item-vat {
  font-size: 12px;
  margin-bottom: 6px;
}

.fetched-contracts {
  padding-left: 24px;
  padding-top: 17px;
}

.ob-order-info-status__manual-tariff {
  margin-top: 14px;
}
</style>
